const pushNodes = (set, domNodes) => {
    domNodes.forEach((domNode) => {
        if (set.has(domNode) === false) {
            set.add(domNode);
        }
    });
};
export const querySelectorAll = (selector, node = document) => {
    if (node instanceof Document ||
        node instanceof HTMLElement ||
        node instanceof ShadowRoot) {
        const domNodes = new Set();
        pushNodes(domNodes, node.querySelectorAll(selector));
        const nodeList = node.querySelectorAll('[class="hydrated"]');
        for (let i = 0; i < nodeList.length; i++) {
            const shadowRoot = nodeList[i].shadowRoot;
            if (typeof shadowRoot === "object" && shadowRoot !== null) {
                pushNodes(domNodes, querySelectorAll(selector, shadowRoot));
            }
            else {
                pushNodes(domNodes, querySelectorAll(selector, nodeList[i]));
            }
        }
        return Array.from(domNodes);
    }
    else {
        throw new Error(`The parameter document for the method querySelectorAll is not type of Document, HTMLElement or ShadowRoot.`);
    }
};
//# sourceMappingURL=index.js.map