(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.querySelectorAll = void 0;
    const pushNodes = (set, domNodes) => {
        domNodes.forEach((domNode) => {
            if (set.has(domNode) === false) {
                set.add(domNode);
            }
        });
    };
    const querySelectorAll = (selector, node = document) => {
        if (node instanceof Document ||
            node instanceof HTMLElement ||
            node instanceof ShadowRoot) {
            const domNodes = new Set();
            pushNodes(domNodes, node.querySelectorAll(selector));
            const nodeList = node.querySelectorAll('[class="hydrated"]');
            for (let i = 0; i < nodeList.length; i++) {
                const shadowRoot = nodeList[i].shadowRoot;
                if (typeof shadowRoot === "object" && shadowRoot !== null) {
                    pushNodes(domNodes, (0, exports.querySelectorAll)(selector, shadowRoot));
                }
                else {
                    pushNodes(domNodes, (0, exports.querySelectorAll)(selector, nodeList[i]));
                }
            }
            return Array.from(domNodes);
        }
        else {
            throw new Error(`The parameter document for the method querySelectorAll is not type of Document, HTMLElement or ShadowRoot.`);
        }
    };
    exports.querySelectorAll = querySelectorAll;
});
//# sourceMappingURL=index.js.map